
import java.awt.*;



final class EfloyPredefined extends Frame {

	Button Button1;
	Button Button2;
	Button Button3;
	Button Button4;
	Button ButtonDefault;
	Button ButtonCancel;


	Label Label1; 
	Label Label2; 
	Label Label3; 
	Label Label4; 
	Label LabelDefault;
	Label LabelCancel;
	
	Label Help;

	Label Labels[];
	Button[] Buttons;
	Label[] DummiesA;
	Label[] DummiesB;
	Label[] DummiesC;

	Panel MainPanel;
	Label TitleLabel;

	Font ButtonFont;

    public EfloyPredefined () {
        super("Vopred definovan populcie a prostredia");
		int i,j;
        
		ButtonFont = new Font("TimesRoman",Font.PLAIN,12);
		setBackground(Color.lightGray);
		setForeground(Color.black);
		InitControls();

		Help = new Label("Tieto vopred definovan nastavenia s len prklad. Kad nastavenie me by zmenen vo Vlastnostiach",Label.CENTER);
		Help.setForeground(Color.blue);
        Panel StatusPanel = new Panel();
        StatusPanel.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));
        StatusPanel.add(Help);
		Font StatusFont = new Font("TimesRoman",Font.BOLD,12);
		Help.setFont(StatusFont);
        this.add("South", StatusPanel);

        Panel TitlePanel = new Panel();
        TitlePanel.setLayout(new FlowLayout(FlowLayout.CENTER, 10, 10));
		TitleLabel = new Label("  Vopred definovan populcie a prostredia  ");
		TitlePanel.add(TitleLabel);
		this.add("North",TitlePanel);
		Font TitleFont = new Font("TimesRoman",Font.BOLD,14);
		TitlePanel.setFont(TitleFont);
		TitlePanel.setForeground(Color.blue);

        MainPanel = new Panel();
		MainPanel.setLayout(new GridLayout(10,1));
		InitMainPanel(MainPanel, Labels, Buttons, DummiesA, DummiesB, DummiesC);

		this.add("Center",MainPanel);

		this.pack();
		this.hide();

	}


	private void InitControls() {

		int i, j;

		Font LabelFont = new Font("TimesRoman",Font.BOLD,12);
		Font ButtonFont = new Font("TimesRoman",Font.BOLD,12);

		Button1 = new Button("Nervzna populcia");
		Button2 = new Button("Flegmatick populcia");
		Button3 = new Button("Opatrn evolcia");
		Button4 = new Button("Riskujcia evolcia");
		ButtonDefault = new Button("Zvo tandartn");
		ButtonCancel = new Button("Zrui");

		Button1.setFont(ButtonFont);
		Button2.setFont(ButtonFont);
		Button3.setFont(ButtonFont);
		Button4.setFont(ButtonFont);
		ButtonDefault.setFont(ButtonFont);
		ButtonCancel.setFont(ButtonFont);

		Labels = new Label[11];
		Buttons = new Button[11];
		DummiesA = new Label[11];
		DummiesB = new Label[11];
		DummiesC = new Label[11];

		for (i=0;i<11;i++) {
			Labels[i] = new Label("");
			Buttons[i] = new Button("");
			DummiesA[i] = new Label("");
			DummiesB[i] = new Label("");
			DummiesC[i] = new Label("");
			Labels[i].setFont(LabelFont);
			Buttons[i].setFont(ButtonFont);
		}

		Labels[0] = new Label("Konfigurcia .1: Energick, rchla, nervzna populcia");
		Labels[1] = new Label("Konfigurcia .2: Pomal, leniv, flegmatick populcia");
		Labels[2] = new Label("Konfigurcia .3: Evolcia, ktor uprednostuje bezpeie nad energiou");
		Labels[3] = new Label("Konfigurcia .4: Evolcia, ktor uprednostuje energiu nad bezpem");
		Labels[4] = new Label("Resetuj na tandartn konfigurciu");
		Labels[5] = new Label("Ponechaj existujce prostredie a populciu");

		for (i=0;i<6;i++) {
			Labels[i].setFont(LabelFont);
			Buttons[i].setFont(ButtonFont);
		}

		Buttons[0] = Button1;
		Buttons[1] = Button2;
		Buttons[2] = Button3;
		Buttons[3] = Button4;
		Buttons[4] = ButtonDefault;
		Buttons[5] = ButtonCancel;

	}
	

	
	private void InitMainPanel(Panel panel, Label[] labels, Button[] buttons, Label[] dummiesa, Label[] dummiesb, Label[] dummiesc) {

		int i;

		GridBagLayout layout = new GridBagLayout();
		panel.setLayout(layout);

		GridBagConstraints constraints = new GridBagConstraints();

		constraints.weightx = 1.0;
		constraints.weighty = 1.0;
		constraints.fill = GridBagConstraints.HORIZONTAL;

		for (i=0;i<6;i++) {
 			constraints.gridwidth = 1;
			layout.setConstraints(dummiesa[i], constraints);
			panel.add(dummiesa[i]);

			constraints.gridwidth = 3;
			layout.setConstraints(Labels[i], constraints);
			panel.add(labels[i]);

			constraints.gridwidth = 1;
			layout.setConstraints(buttons[i], constraints);
			panel.add(Buttons[i]);


			constraints.gridwidth = GridBagConstraints.REMAINDER;
			layout.setConstraints(dummiesb[i], constraints);
			panel.add(dummiesb[i]);

		}

		panel.resize(panel.preferredSize());

	}
	


	void DefaultParams() {

		Efloys.params[0].value = 5f;		//MaxSpeed
		Efloys.params[1].value = 0.8f;		//BounceSpeed
		Efloys.params[2].value = 0.3f;		//ApproachAcceleration
		Efloys.params[4].value = 0.1f;		//CenterAcceleration
		Efloys.params[5].value = 1f;			//DistBrotherFactor
		Efloys.params[6].value = 20f;		//DistStrangerFactor
		Efloys.params[7].value = 0f;			//DistLocalFactor
		Efloys.params[8].value = 200f;		//CollisionDistance
		Efloys.params[9].value = -1f;		//CollisionBrotherFactor
		Efloys.params[10].value = 30f;		//CollisionStrangerFactor
		Efloys.params[11].value = -40f;		//CollisionLocalFactor

		Efloys.fixpars[5].value = 2f;		//NumberOfNeighbors
		Efloys.fixpars[6].value = 0.1f;		//MutationFactor
		Efloys.fixpars[7].value = 1f;		//CrossoverFactor
		Efloys.fixpars[8].value = 10f;		//energy
		Efloys.fixpars[9].value = 10f;		//safety
		Efloys.fixpars[10].value = 10f;		//cooperation

		Efloys.envpars[5].value = 1f;		//EnergyFactor
		Efloys.envpars[6].value = 1f;		//SafetyFactor
		Efloys.envpars[7].value = 0f;		//CooperationFactor
		Efloys.envpars[8].value = 0f;		//SurviversFactor
		Efloys.envpars[12].value = 10f;		//PopulationSize
		Efloys.envpars[13].value = 0.05f;	//FreeWillFactor"
		Efloys.envpars[14].value = 50f;		//LifeSpan

		Efloys.NF = (int) Efloys.envpars[12].value;
		Efloys.SLEEP = (long) Efloys.envpars[3].value;
		Efloys.KICK =  Efloys.envpars[13].value;
		Efloys.sldPocet.setValue((int) Efloys.envpars[12].value);
 	    Efloys.sldRychlost.setValue((int) (100 - Efloys.envpars[3].value));


	}


	void UpdateParams(int num) {

		DefaultParams();

		if (num == 1) {
			Efloys.params[0].value = 8f;		//MaxSpeed
			Efloys.params[1].value = 2f;		//BounceSpeed
			Efloys.params[2].value = 0.8f;		//ApproachAcceleration
			Efloys.params[4].value = 0.1f;		//CenterAcceleration
			Efloys.params[5].value = 3f;		//DistBrotherFactor
			Efloys.params[6].value = 40f;		//DistStrangerFactor
			Efloys.params[7].value = 0f;		//DistLocalFactor
			Efloys.params[8].value = 200f;		//CollisionDistance
			Efloys.params[9].value = -1f;		//CollisionBrotherFactor
			Efloys.params[10].value = 50f;		//CollisionStrangerFactor
			Efloys.params[11].value = -50f;		//CollisionLocalFactor
			Efloys.InEvolution = false;
			Efloys.NewGeneration = false;
			Efloys.Evolution.setLabel("tart evolcie");
		}
		else
		if (num == 2) {
			Efloys.params[0].value = 1f;		//MaxSpeed
			Efloys.params[1].value = 0.1f;		//BounceSpeed
			Efloys.params[2].value = 0.05f;		//ApproachAcceleration
			Efloys.params[4].value = 0f;		//CenterAcceleration
			Efloys.params[5].value = 1f;		//DistBrotherFactor
			Efloys.params[6].value = 10f;		//DistStrangerFactor
			Efloys.params[7].value = 0f;		//DistLocalFactor
			Efloys.params[8].value = 200f;		//CollisionDistance
			Efloys.params[9].value = -1f;		//CollisionBrotherFactor
			Efloys.params[10].value = 10f;		//CollisionStrangerFactor
			Efloys.params[11].value = -20f;		//CollisionLocalFactor
			Efloys.InEvolution = false;
			Efloys.NewGeneration = false;
			Efloys.Evolution.setLabel("tart evolcie");
		}
		else
		if (num == 3) {
 			Efloys.envpars[5].value = 1f;		//EnergyFactor
			Efloys.envpars[6].value = 3f;		//SafetyFactor
			Efloys.envpars[7].value = 0f;		//CooperationFactor
			Efloys.envpars[8].value = 0f;		//SurviversFactor
			Efloys.envpars[12].value = 25f;		//PopulationSize
			Efloys.envpars[13].value = 0.05f;	//FreeWillFactor"
			Efloys.envpars[14].value = 25f;		//LifeSpan
			Efloys.InEvolution = true;
			Efloys.NewGeneration = true;
			Efloys.Evolution.setLabel("Stop evolcie");
		}
		else
		if (num == 4) {
 			Efloys.envpars[5].value = 3f;		//EnergyFactor
			Efloys.envpars[6].value = 1f;		//SafetyFactor
			Efloys.envpars[7].value = 0f;		//CooperationFactor
			Efloys.envpars[8].value = 0f;		//SurviversFactor
			Efloys.envpars[12].value = 25f;		//PopulationSize
			Efloys.envpars[13].value = 0.05f;	//FreeWillFactor"
			Efloys.envpars[14].value = 25f;		//LifeSpan
			Efloys.InEvolution = true;
			Efloys.NewGeneration = true;
			Efloys.Evolution.setLabel("Stop evolcie");
		}

		Efloys.NF = (int) Efloys.envpars[12].value;
		Efloys.SLEEP = (long) Efloys.envpars[3].value;
		Efloys.KICK =  Efloys.envpars[13].value;
		Efloys.sldPocet.setValue((int) Efloys.envpars[12].value);
 	    Efloys.sldRychlost.setValue((int) (100 - Efloys.envpars[3].value));

	}





	public boolean mouseExit(Event evt, int x, int y) {

		Help.setText("");
		return true;

	}



    public boolean action(Event e, Object arg) {


		int i, j, num;
		boolean ok = true;

        if (e.target == Button1) {
			UpdateParams(1);
		}
        if (e.target == Button2) {
			UpdateParams(2);
		}
        if (e.target == Button3) {
			UpdateParams(3);
		}
        if (e.target == Button4) {
			UpdateParams(4);
			Efloys.appcontext.showStatus("Tlaidlo .4");
		}
        if (e.target == ButtonDefault) {
			DefaultParams();
			Efloys.appcontext.showStatus("Tlaidlo .5");
		}
        if (e.target == ButtonCancel) {
			ok = false;
		}
		
		if (ok) {
			Efloys.ResetPopulation = true;
			Efloys.First = true;
		}

        this.hide();
        this.dispose();
        return true;

	}


	public boolean handleEvent(Event ev) {

	    if (ev.id == Event.WINDOW_DESTROY) {
            this.hide();
            this.dispose();
            return true;
		}
		else
			return super.handleEvent(ev);

	} 

}
    